# vim: set ts=4 sw=4 et:

%{!?python_sitelib:  %global python_sitelib  %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}

Name:           nicotine-plus
Version:        1.2.16
Release:        lp150.3.6
Summary:        Client for the SoulSeek Filesharing Network
Source:         http://prdownloads.sourceforge.net/nicotine-plus/nicotine+-%{version}.tar.bz2
Patch1:         nicotine-plus-trayicon-makefile-fixes.patch
Patch2:         nicotine-plus-pygtk-codegen.patch
Patch3:         nicotine-plus-noexec.patch
Patch4:         nicotine-plus-fix_desktop.patch
Source99:       %{name}-rpmlintrc
URL:            http://nicotine-plus.sourceforge.net/
Group:          Productivity/Networking/Other
License: GPL-2.0
BuildRoot:      %{_tmppath}/build-%{name}-%{version}
BuildRequires:  python python-devel python-gtk gcc make gtk2-devel
BuildRequires:  libnotify-devel
BuildRequires:  update-desktop-files
BuildRequires:  hicolor-icon-theme
BuildRequires:  python-mutagen
BuildRequires:  python-miniupnpc
%if %suse_version >= 1020
BuildRequires:  python-gtk-devel
%endif
Requires:       python-gtk
Recommends:     python-miniupnpc
Recommends:     python-mutagen
Recommends:     python-sexy
Obsoletes:      nicotine < %{version}
Provides:       nicotine = %{version}
%py_requires

%description
Nicotine is a SoulSeek client written in Python, based on the PySoulSeek
and Nicotine projects.

%prep
%setup -q -n "nicotine+-%{version}"
%patch1
%patch2
%patch3
%patch4

%build
%__python ./setup.py build

pushd trayicon
%__python ./autogen.py
%__make OPTFLAGS="%{optflags}" LIB="%{_lib}" CC="%__cc"
popd #trayicon

%install
%__python ./setup.py install --prefix="%{_prefix}" --root="%{buildroot}" \
    --record-rpm=rpmfiles.lst

%__perl -ni -e 'print unless m|^%{_mandir}/|' rpmfiles.lst
%__perl -ni -e 'print unless m|^%{_datadir}/locale/|' rpmfiles.lst
%__perl -ni -e 'print unless m,^(%dir\s+)?%{_datadir}/(applications|pixmaps)/?$,' rpmfiles.lst

%__rm "%{buildroot}%{python_sitelib}/pynicotine/gtkgui/glade2py".py*
%__perl -ni -e 'print unless m|^%{python_sitelib}/pynicotine/gtkgui/glade2py\.py|' rpmfiles.lst

%__install -D -m0755 trayicon/trayicon.so "%{buildroot}%{py_sitedir}/pynicotine/trayicon.so"

pushd files
for f in nicotine-plus-*px.png; do
    s="${f##*-}"
    s="${s%px.png}"
    %__install -D -m0644 "$f" "%{buildroot}%{_datadir}/icons/hicolor/${s}x${s}/apps/nicotine-plus.png"
done
popd #files

%suse_update_desktop_file -r "nicotine" Network P2P

%__rm -rf "%{buildroot}%{_datadir}/locale/dk"
%find_lang nicotine

cat rpmfiles.lst nicotine.lang > files.lst

%__ln_s nicotine.py "%{buildroot}%{_bindir}/nicotine"

%clean
%{?buildroot:%__rm -rf "%{buildroot}"}

%files -f files.lst
%defattr(-,root,root)
%doc COPYING
%{_bindir}/nicotine
%if "%{python_sitearch}" != "%{python_sitelib}"
%{python_sitearch}/pynicotine
%endif
%{python_sitearch}/pynicotine/trayicon.so
%if %suse_version >= 1020
%{python_sitelib}/nicotine-%{version}-py%{py_ver}.egg-info
%endif
%{_datadir}/icons/hicolor/*/apps/nicotine-plus.png
%doc %{_mandir}/man1/nicotine.1%{ext_man}
%doc %{_mandir}/man1/nicotine-import-winconfig.1%{ext_man}

%changelog
* Wed Mar  9 2011 pascal.bleser@opensuse.org
- update to 1.2.16
  * updated most country flags (#599)
  * all messages should now be properly timestamped in the log (#602)
  * saving user pictures now appends a timestamp so pictures aren't overwritten
  * division-by-zero errors broke transfers (#561)
  * some packets were packed incorrectly (#570)
  * recursive downloads didn't work (#571)
  * search results were improperly formatted (#594)
  * copying folder URLS didn't work (#574)
  * mid sentence tab completion destroyed input (#562)
  * portmapping with MiniUPnPc (the binary) didn't work (#593)
  * deprecated raise statements using strings (#613)
  * transparency wasn't saved properly (#615)
  * shares didn't work properly with out-of-ASCII characters (#623, #345)
  * fileshare counter increased on refreshing a filelist (#617)
  * program failed to start with a corrupt transfer file (#628)
  * network loop crashed on invalid DistribSearch packets
  * private rooms often didn't show up in the room list (#641)
  * nicotine.desktop was missing P2P and Network sub categories (#660)
* Sun Mar  7 2010 pascal@links2linux.de
- update to 1.2.15:
  * when using an upload slot limit, uploads that don't start within
  30 seconds are no longer counted as a used slot -- this stops a
  single faulty user from preventing other connections
  * the clear button in the upload view now clears erred transfers
  too
  * unhide user info tab when a new userinfo is received
  * transfer views update less frequently reducing the amount of CPU
  needed
  * xdg-open is now used by default to open folders and play music
  * Now-Playing support for Amarok2 (Ticket #423)
  * FastConfigure dialog for new users (Ticket #482)
  * Country flags now have tooltips (Ticket #521)
  * Now-Playing support for Banshee
  * collapse mode in upload/download didn't work for newly added
  files, wasn't remembered with restart (ticket #205)
  * the packing/unpacking of network messages has been made more
  explicit; his should make Nicotine+ less likely to fail on
  different processor types and operating systems (Tickets #486
  [#493] #518 #540 #548)
  * ban list got unintentionally deleted sometimes (Ticket #519)
  * "Show IP" didn't not work on the userinfo page (Ticket #522)
  * wishlist searches would stop working if the setting "Reopen
  search tabs" was disabled and the user closed the search tab
  (Ticket #552)
  * incoming RoomSearch raised exceptions
  * updated French translation
  * updated Hungarian translation
- changes from 1.2.14:
  * a corrupt configuration file will no longer make Nicotine+ fail
  on startup (ticket #483)
  * multiple shares can now be loaded from the harddrive at the same
  time
  * support for UPnP through MiniUPnPc (ticket #230)
  * search failed to work on certain combinations of OS and processor
  (ticket #486)
  * implemented our own filelist iterator, dramatically reducing the
  amount of CPU cycles needed to open filelists (ticket #480)
  * bitrates for Musepack audio were scanned incorrectly
  * saving file lists from users with slashes in the name didn't
  work
  * filesize was incorrect for files around 2 gigabytes and up in
  userbrowse
- changes from 1.2.13:
  * download queue is stored independently from the normal
  configuration file (ticket #467)
  * non-working connections are cleaned up more aggressively
  (ticket #473)
  * themes can now use a range of image types, including SVG
  * ownership of private rooms is now displayed
  * search chatroom logs by pressing F3
  * ASF Support in case Mutagen is used
  * the location of Nicotine+ is restored on startup
  * rudimentary download rate limiter
  * the NowPlaying code for Audacious now supports audtool2 as well
  * notifications failed when a user had <> in the name
  * highlight icon kept on blinking with detached windows
  * fixed links in the Help menu that didn't work (ticket #459)
  * a few different GUI related bugs that should make Nicotine+ much
  more responsive and use less CPU:
  + startup time reduced when there is a queue
  +  queueing many items at a timer
  + pressing buttons like "Clear Finished" and "Abort User's
    Upload(s)"
  * fixed and lots of tiny bugs
  * updated Lithuanian translation
  * updated Dutch translation
  * updated Hungarian translation
* Sun Feb 28 2010 pascal@links2linux.de
- add symlink "nicotine" (to nicotine.py)
- add Recommends for python-mutagen, provides better tag analysis
* Sun Jan 10 2010 pascal.bleser@opensuse.org
- update to 1.2.12
* Mon May 25 2009 pascal.bleser@opensuse.org
- update to 1.2.10:
  * added support for RGBA, enabling Murrine users to use transparency and round menus
  * tabs can be reorderen and can be hidden
  * fixed bug #177, notification popups are now split into file and directory notifications
  * fixed bug #274, cancelling and disowning private rooms bug (fr3shpr1nc3)
  * fixed bug #226, file size dropdown in search filters are more readable now
  * fixed bug #310, activity icon no longer activates on our own typing
  * timestamps in private messages now are displayed correctly
  * added last.fm to the now-player
  * added first version of the plugin system
  * tabs can be closed using the middle mouse button
  * usernames can be copied from the channel list (right click, select the username from the menu)
  * added a popup that will inform users in case a local port cannot be bound
  * connections will be dropped when the maximum is approached, decreasing the chance for "IOError" messages
  * 'send to player' failed because of missing quotes for finished downloads
  * fixed a bug with tuple error message causing a traceback
  * fixed a translation bug, caused by tabs positions top, left, etc that caused settings dialog to not work properly
  * fixed rhythmbox support with "Now Playing"
  * fixed Audacious support with "Now Playing"
  * fixed sending out the wrong username with search results
  * updated all server references to the new server
  * a inverted port range no longer causes connection failures
  * removed deprecated GTK calls
  * buddylist: radio buttons now allow the buddylist to be toggled as always visible, in own tab, or in the chatroom tab
  * the Edit menu has been broken into Edit, View and Shares menus
  * committed QuinoX's patch for case-insensitive nick completion (#252)
  * added Server Message 141, enables Private Chat Room Invitations and thus allows those you invite to get past the annoying server message that warning when a user you've invited 'hasn't enabled private room add'
  * blocking a user's IP address is now easier with the addition of a chatroom popup menu item
  * private Rooms: you can now create private rooms via the roomslist popup menu and add users to your private rooms via any chatroom user popup-menu. You can also drop ownership of a private room and drop membership of another person's private room. This feature is currently available on the testing server only
  * country flags are shown in search results, metadata dialogs
  * ypload and Download transfer lists now have customizable double-click options in Transfers->Events.
  * a Backup config menu item was added to the Edit menu. This will backup your Nicotine+ config and config.alias (if it exists) into a BZ2 archive. If you cancel the backup filename saving process, an archive with the format 'config backup YYYY-MM-DD HH:MM:SS.tar.bz2' will be created
  * visible colors have been added to the Colour settings (for those who don't read hexadecimal)
  * separate fonts for Search, Transfers, Browse and a font for all other lists can now be set
* Mon Oct  1 2007 guru@unixtech.be
- moved to Packman
- new upstream version
* Wed Jul 18 2007 guru@unixtech.be
- new upstream version
* Tue Mar 13 2007 guru@unixtech.be
- CHANGES: option to copy was added to some of the popup menus
- CHANGES: progress bar for share scanning now vanishes properly
- CHANGES: attempted fix was made for 'interrupted system call' crashing the network loop
- CHANGES: username hotspots for offline/left users aren't disabled
- CHANGES: directory cropping was fixed in 'upload directory to' in User Browse
- CHANGES: remote-uploading was improved somewhat, as it was quite buggy with two Nicotine+ clients
- CHANGES: bugs in transfer slots and popups were fixed
- CHANGES: Spanish, French, Dutch, Italian, and Lithuanian translations were updated
- new upstream version
* Sun Dec 10 2006 guru@unixtech.be
- added missing Requires for python-gtk
* Sun Nov 26 2006 guru@unixtech.be
- added .egg-info for SUSE 10.2
* Sat Oct 21 2006 guru@unixtech.be
- new upstream version
* Sun Sep 10 2006 guru@unixtech.be
- fixed .desktop file, was starting "nicotine-plus" instead of "nicotine" (thanks to cb400f for reporting)
* Tue Aug 22 2006 guru@unixtech.be
- new package
